// my_first_plugin.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"

BZ_GET_PLUGIN_VERSION

bool spawnpos[256]={0};
bool shield=0;
float outspawns[5][5]={{0}};

class my_first_plugin_events : public bz_EventHandler
{
  virtual void process ( bz_EventData *eventData )
  { 
  
  
  
    if(eventData->eventType==bz_ePlayerDieEvent)
    {
      bz_PlayerDieEventData* data = (bz_PlayerDieEventData*)eventData;
      
      if(data->killerTeam==eNoTeam){spawnpos[data->playerID]=0;}
      else{spawnpos[data->playerID]=1;}
    }
    
    
    else if(eventData->eventType==bz_eCaptureEvent)
    {
      for(int i=0; i<256; i++)
      {
        spawnpos[i]=0;
      }
      float firepos[3]={0};
      bz_fireWorldWep("SW",10,BZ_SERVER,firepos,0,0,0,0.0f);
    }
    
    
    else if(eventData->eventType==bz_eGetPlayerSpawnPosEvent)
    {
      bz_GetPlayerSpawnPosEventData* data = (bz_GetPlayerSpawnPosEventData*)eventData;
      if(spawnpos[data->playerID])
      {
        int teamnumber=1;
        switch(data->team)
        {
          case eRogueTeam: teamnumber=0; break;
          case eRedTeam: teamnumber=1; break;
          case eGreenTeam: teamnumber=2; break;
          case eBlueTeam: teamnumber=3; break;
          case ePurpleTeam: teamnumber=4; break;
          default: break;
        }
        data->pos[0]=(int)((rand()%((int)(outspawns[teamnumber][1]-outspawns[teamnumber][0])))+outspawns[teamnumber][0]);
        data->pos[1]=(int)((rand()%((int)(outspawns[teamnumber][3]-outspawns[teamnumber][2])))+outspawns[teamnumber][2]);
        data->pos[2]=outspawns[teamnumber][4];
      }
    }
    
    
    else if(eventData->eventType==bz_ePlayerPartEvent)
    {
      bz_PlayerJoinPartEventData* data = (bz_PlayerJoinPartEventData*)eventData;
      spawnpos[data->playerID]=0;
    }
    
    else if(eventData->eventType==bz_ePlayerSpawnEvent)
    {
      bz_PlayerSpawnEventData* data = (bz_PlayerSpawnEventData*)eventData;
      if(shield)bz_givePlayerFlag(data->playerID,"SH",0);
    }
 
    
  }
};

my_first_plugin_events my_first_plugin_events;

class my_first_plugin_slashcommands : public bz_CustomSlashCommandHandler
{
public:
  virtual bool handle ( int playerID, bzApiString command, bzApiString /*message*/, bzAPIStringList *params )
  {
    
    bz_PlayerRecord	*playerdata;
    playerdata = bz_getPlayerByIndex(playerID);
    if(!playerdata||!playerdata->admin){bz_freePlayerRecord(playerdata); return 0;}
    bz_freePlayerRecord(playerdata);
    
    if(command=="shield")
    {
      if(params->get(0)=="off" || params->get(0)=="0")
      {shield=0;}
      else if(params->get(0)=="on" || params->get(0)=="1")
      {shield=1;}
      else { bz_sendTextMessage(BZ_SERVER,playerID,"Usage: /shield <on|off>"); }
      return 1;
    }
    else if(command=="restartspawn")
    {
      for(int i=0; i<256; i++)
      {
        spawnpos[i]=0;
      }
      float firepos[3]={0};
      bz_fireWorldWep("SW",10,BZ_SERVER,firepos,0,0,0,0.0f);
      return 1;
    }
    return 0;
  }
};

my_first_plugin_slashcommands my_first_plugin_slashcommands;

class my_first_plugin_mapobjects : public bz_CustomMapObjectHandler
{ 
public:
	virtual bool handle ( bzApiString object, bz_CustomMapObjectInfo *data )
     {
       if(object!="OUTSPAWN")return 0;
       float x=0,y=0,z=0,xsize=0,ysize=0;
       int team=1;
       for ( unsigned int i = 0; i < data->data.size(); i++ )
	  {
		std::string line = data->data.get(i).c_str();

		bzAPIStringList *nubs = bz_newStringList();
		nubs->tokenize(line.c_str()," ",0,true);
		
		if ( nubs->size() > 0)
		{
			std::string key = bz_toupper(nubs->get(0).c_str());
			if ( key == "POSITION" && nubs->size() > 3)
			{
				x = (float)atof(nubs->get(1).c_str());
				y = (float)atof(nubs->get(2).c_str());
				z = (float)atof(nubs->get(3).c_str());
			}
               else if ( key == "SIZE" && nubs->size() > 3)
			{
				xsize = (float)atof(nubs->get(1).c_str());
				ysize = (float)atof(nubs->get(2).c_str());
			}
			else if ( key == "TEAM" && nubs->size() > 1)
			{
				team=(int)atoi(nubs->get(1).c_str());
			}

		}
		bz_deleteStringList(nubs);
	  }
       outspawns[team][0]=x-xsize;
       outspawns[team][1]=x+xsize;
       outspawns[team][2]=y-ysize;
       outspawns[team][3]=y+ysize;
       outspawns[team][4]=z;
       return 1;
     }
};

my_first_plugin_mapobjects my_first_plugin_mapobjects;

BZF_PLUGIN_CALL int bz_Load ( const char* commandLine )
{
  bz_debugMessage(4,"my_first_plugin plugin loaded");
  bz_registerEvent(bz_ePlayerDieEvent,&my_first_plugin_events);
  bz_registerEvent(bz_eCaptureEvent,&my_first_plugin_events);
  bz_registerEvent(bz_eGetPlayerSpawnPosEvent,&my_first_plugin_events);
  bz_registerEvent(bz_ePlayerSpawnEvent,&my_first_plugin_events);
  bz_registerEvent(bz_ePlayerPartEvent,&my_first_plugin_events);
  bz_registerCustomSlashCommand("shield",&my_first_plugin_slashcommands);
  bz_registerCustomSlashCommand("restartspawn",&my_first_plugin_slashcommands);
  bz_registerCustomMapObject("outspawn",&my_first_plugin_mapobjects);
  if(&commandLine[0]) shield=atoi(&commandLine[0]);
  return 0;
}

BZF_PLUGIN_CALL int bz_Unload ( void )
{
  bz_debugMessage(4,"my_first_plugin plugin unloaded");
  bz_removeEvent(bz_ePlayerDieEvent,&my_first_plugin_events);
  bz_removeEvent(bz_eCaptureEvent,&my_first_plugin_events);
  bz_removeEvent(bz_eGetPlayerSpawnPosEvent,&my_first_plugin_events);
  bz_removeEvent(bz_ePlayerSpawnEvent,&my_first_plugin_events);
  bz_removeEvent(bz_ePlayerPartEvent,&my_first_plugin_events);
  bz_removeCustomSlashCommand("shield");
  bz_removeCustomSlashCommand("restartspawn");
  bz_removeCustomMapObject("outspawn");
  return 0;
}

// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8
